<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">

      <el-form-item label="分类名称" prop="categoryName">
        <el-input
          v-model="queryParams.categoryName"
          placeholder="请输入分类名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:category:add']"
        >新增</el-button>
      </el-col>


      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="categoryList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
<!--      <el-table-column label="主键" align="center" prop="id" />-->
<!--      <el-table-column label="父分类" align="center" prop="pid" />-->
      <el-table-column label="分类名称" align="center" prop="categoryName" />
      <el-table-column label="排序" align="center" prop="orderNum" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:category:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:category:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改【请填写功能名称】对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="900px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="排序" prop="orderNum">
          <el-input v-model="form.orderNum" placeholder="请输入排序" />
        </el-form-item>
        <el-form-item label="分类名称" prop="categoryName">
          <el-input v-model="form.categoryName" placeholder="请输入分类名称" />
        </el-form-item>
        <el-form-item label="图标" prop="shopImages">
          <image-upload v-model="form.image"/>
        </el-form-item>


          <div  v-for="(item,index) in form.templates" :key="index" style="width: 100%; display: flex; align-items: center">
              <el-form-item label="规格名称" prop="categoryName">
                <el-input v-model="item.skuName" placeholder="请输入规格名称" />
              </el-form-item>
            <el-form-item label="价格" prop="categoryName">
              <el-input-number v-model="item.skuPrice" @change="handleChange" :min="0" :max="999999999" label="请输入价格"></el-input-number>
            </el-form-item>
            <div style="margin-left: 20px">
              <el-button
                size="mini"
                type="text"
                icon="el-icon-delete"
                @click="deletecomm(index)"
                v-hasPermi="['system:category:remove']"
              >删除</el-button>
            </div>
          </div>


        <div style="width: 100%; margin: 20px auto; display: flex;align-items: center; justify-content: flex-end ">
          <el-button type="primary" icon="el-icon-plus" @click="addCommodity()" >新增</el-button>
        </div>
      </el-form>

      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
   import { listCategory, getCategory, delCategory, addCategory, updateCategory } from "../api/inspection";

  export default {
    name: "Category",
    data() {
      return {

          skuName:'',
          skuPrice:'',
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 【请填写功能名称】表格数据
        categoryList: [],
        // 弹出层标题
        titletitle: "编辑",
        // 是否显示弹出层
        open: false,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          pid: null,
          categoryName: null,
          orderNum: null
        },
        // 表单参数
        form: {
          image:'',
          templates:[{
            skuName:'',
            skuPrice:0
          }]
        },
        // 表单校验
        rules: {
        }
      };
    },
    created() {
      this.getList();
    },
    methods: {
      /** 查询【请填写功能名称】列表 */
      getList() {
        this.loading = true;
        listCategory(this.queryParams).then(response => {
          this.categoryList = response.data.list;
          this.total = response.data.total;
          this.loading = false;
        });
      },
      addCommodity(){
        let data = {
          skuName:this.skuName,
          skuPrice:this.skuPrice
        }
        this.form.templates.push(data)
      },
      deletecomm(index){
        this.form.templates.splice(index, 1);
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      handleChange(value) {
        console.log(value);
      },
      // 表单重置
      reset() {
        this.form = {
          id: null,
          pid: null,
          categoryName: null,
          orderNum: null,
          templates:[{
            skuName:'',
            skuPrice:0
          }]
        };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id)
        this.single = selection.length!==1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "新增";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        getCategory(row.id).then(res=>{
          this.form = res.data;
          this.form.templates.forEach(it=>{
            it.skuPrice = it.skuPrice / 100
          })
        })
        this.open = true;
        this.title = "编辑";
      },
      /** 提交按钮 */
      submitForm() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id != null) {
              let json = JSON.parse(JSON.stringify(this.form))
              json.templates.forEach(it=>{
                it.skuPrice = it.skuPrice *100
              })
              updateCategory(json).then(response => {
                this.$modal.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else {
              let json = JSON.parse(JSON.stringify(this.form))
              json.templates.forEach(it=>{
                it.skuPrice = it.skuPrice *100
              })
              addCategory(json).then(response => {
                this.$modal.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        this.$modal.confirm('是否确认删除？').then(function() {
          return delCategory(ids);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
      },
      /** 导出按钮操作 */
      handleExport() {
        this.download('system/category/export', {
          ...this.queryParams
        }, `category_${new Date().getTime()}.xlsx`)
      }
    }
  };
</script>

